SHEBANG
# Copyright @BABOLO (C)2009 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.1.2.2 2009/07/19 23:17:43 babolo Exp $

JNTROSTUP(sendmail,,sendmaildnl
,dnl
# jailup ${kind} dir jailname jailaddr [port]
#     where jailname - hostname for jail (see jail(2) hostname)
#           jailaddr - IP addr for jail (see jail(2) ip_number)
#           dir relative to ${JAILUPDIR} and ${JAILRODIR}
# system /usr/sbin/sendmail
#                                                   useddnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
user=root
group=wheel
port="${4:-25}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"

${mkdir} "${main_dir}" "${conf_dir}/mail"
${up_mdir} "${main_dir}" ${MTREE}
ETCOPY(protocols resolv.conf services)
sendmail=`${awk} '/^send-mail[	 ]/{print $2}' ${etcdir}/mail/mailer.conf`
echo ${sendmail}                | ${up_libexe} "${main_dir}/usr/libexec/"
${up_genlist} usr/libexec/ ${MTREE} | ${up_libexe} "${main_dir}/usr/libexec/"
echo ${sendmail}                | ${up_ldsh} "${main_dir}/usr/libexec/" | ${up_shlib} "${main_dir}/usr/lib"
echo "/usr/libexec/mail.local" | ${up_ldsh} "${main_dir}/usr/libexec/" | ${up_shlib} "${main_dir}/usr/lib"

${up_acc} gr "${conf_dir}" <<- EOF
	wheel:*:0:
	daemon:*:1:
	mail:*:6:
	nogroup:*:65533:
	nobody:*:65534:
EOF

${up_acc} pwt "${conf_dir}" <<- EOF
	root:*:0:0::0:0:Charlie &:/:/dev/null/none
	nobody:*:65534:65534::0:0:Unprivileged user:/dev/null/none:/dev/null/none
EOF

for i in aliases helpfile mailer.conf sendmail.cf; do
    if  [ -f "${etcdir}/mail/${i}" ]; then
        cf="${i}"; if  [ -e "${conf_dir}/mail/${cf}" ]; then cf="${cf}.sample"; fi
        ${sed} -e 's|/usr/libexec/sendmail/|/usr/libexec/|g' "${etcdir}/mail/${i}"\
        > "${conf_dir}/mail/${cf}"
        if   [ -f "${conf_dir}/mail/${i}.sample" ]\
          && ${diff} -bBdqa "${conf_dir}/mail/${i}" "${conf_dir}/mail/${i}.sample" 2>/dev/null
        then
            ${rm} -f "${conf_dir}/mail/${i}.sample"
    fi; fi
done

${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << "EOF"
/set type=file uname=root gname=wheel mode=0644 flags=none
.			type=dir mode=0755
    group
    localtime
    protocols
    resolv.conf
    services
    master.passwd	mode=0600
    mail		type=dir mode=0755
/set mode=0644
        aliases
        helpfile	mode=0444
        mailer.conf
        sendmail.cf
    ..
..
EOF

${pwd_mkdb} -d "${conf_dir}" -p "${conf_dir}/master.passwd"
${sendmail} -bi -O AliasFile="${conf_dir}/mail/aliases"
${up_adc} "${JAILUPRC}" <<- EOF
#${genclass}	${inclass}	${jdir}	${jailsname}	${jailsaddr}	0	${user}	${group}	${port}	30m
EOF
      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${up_adc} "${etcdir}/fstab" <<- EOF
	#/null			${main_dir}/dev	null	ro,noexec	0 0
	#${conf_dir}		${main_dir}/etc	null	ro,nodev,noexec	0 0
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
